﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Web.Mvc;
using Html5Representor.Models;
using Html5Representor.StockatoWS;

// What's left:

// #1 In the input textbox - once the user starts typing one or more letters a list of 5 financial instruments is presented. Once he clicks on one of the symbols he recevies similarities.
//    Use: var top5 = client.StockatoDecade_GetFinancialInstrumentsAndDescriptions(instrument);

// #2 A vertical scroller (in case we want to pull more results - like 50 or 100).

// #3 The top result is the same as the symbol specified. It should not included in the list of results.

// #4 Once the page is launched it should immediatelly show some default results.

// #5 Increase the font sizes. Hard to read - I'm too old. :-)

// #6 Present "Loading ..." when the results are loading.

// #7 Present "No matches found." when the user types some random text.

// #8 Set max limitation for the number of charachters to type at the input textbox (10 is O.K.).

// Xiaomin - do you know how to have http://localhost:36270/behaviorbasedsearch/ launched instead of http://localhost:36270/ when I click F5?

// Many thanks. Uri

namespace Html5Representor.Controllers
{
    public class BehaviorBasedSearchController : Controller
    {
        private const int NUM_SYMBOLS_TO_RETRIEVE = 11;        

        public ActionResult Index()
        {
            ViewBag.DefaultInstrumentStr = "EWZ";

            return View();
        }

        public ActionResult Search(string instrument)
        {
            ViewBag.DefaultInstrumentStr = instrument;

            List<BehaviorBasedSearchVM> instruments = null;
            try
            {
                using (var client = new StockatoAzureGeneralWSSoapClient())
                {
                    var result = client.StockatoDecade_GetSimilarFinancialInstrumentsOptimized(instrument,
                                                                                               NUM_SYMBOLS_TO_RETRIEVE,
                                                                                               "All Categories");                    
                    
                    instruments = StockatoWSHelper.GetInstrumentsFromStringValue(result);                    
                }
            }
            catch (Exception ex)
            {
                Trace.TraceError("{0}\n{1}",ex.Message, ex.StackTrace);
            }

            return PartialView("_InstrumentList", instruments);
        }
    }
}
